/*
 * ComponentStream.java
 *
 * The contents of this file are subject to the GNU Lesser General Public License
 * Version 2.1 (the "License"). You may not copy or use this file, in either
 * source code or executable form, except in compliance with the License. You
 * may obtain a copy of the License at http://www.fsf.org/licenses/lgpl.txt or
 * http://www.opensource.org/. Software distributed under the License is
 * distributed on an "AS IS" basis, WITHOUT WARRANTY OF ANY KIND, either express
 * or implied. See the License for the specific language governing rights and
 * limitations under the License.
 */

package net.outer_planes.jso;

import org.jabberstudio.jso.StreamContext;
import org.jabberstudio.jso.util.IdentityGenerator;
import org.jabberstudio.jso.util.Utilities;

/**
 *
 * @author  linuxwolf
 * @version 0.13-DEV-20050624155226
 * @since   JSO-0.2
 */
public class ComponentStream extends AbstractStream {
    //Constructors
    /** Creates a new instance of BasicStream */
    public ComponentStream(JSO jso, DataFactory df, String ns, StreamContext inCtx, StreamContext outCtx) {
        super(jso, df, ns, inCtx, outCtx);
    }
    
    //Methods
    protected void setupOpen() throws Exception {
        StreamContext       out = getOutboundContext();
        StreamContext       in = getInboundContext();
        String              host = getSource().getHostname();
        
        //Setup outbound context
        if (getInboundStatus().isOpened()) {
            //Setup "from"
            if (out.getFrom() == null)
                out.setFrom(createJID(host));
            //Setup session ID
            if (!Utilities.isValidString(out.getID()))
                out.setID(new IdentityGenerator().generate("component"));
        } else {
            //Setup "to"
            if (out.getTo() == null)
                out.setTo(createJID(host));
        }
    }
}