/*
 * StandardPacketFactory.java
 *
 * The contents of this file are subject to the GNU Lesser General Public License
 * Version 2.1 (the "License"). You may not copy or use this file, in either
 * source code or executable form, except in compliance with the License. You
 * may obtain a copy of the License at http://www.fsf.org/licenses/lgpl.txt or
 * http://www.opensource.org/. Software distributed under the License is
 * distributed on an "AS IS" basis, WITHOUT WARRANTY OF ANY KIND, either express
 * or implied. See the License for the specific language governing rights and
 * limitations under the License.
 */

package net.outer_planes.jso;


import org.jabberstudio.jso.NSI;

/**
 *
 * @author  linuxwolf
 * @version 0.13-DEV-20050624155226
 * @since   JSO-0.2
 */
public class StandardPacketFactory extends AbstractElementFactory {
    //Constructors
    public StandardPacketFactory() throws IllegalArgumentException {
        super(NSI.STRICT_COMPARATOR);
    }

    //Methods
    protected void registerSupportedElements() throws IllegalArgumentException {
        putSupportedElement(new InfoQueryPacket(null));
        putSupportedElement(new MessagePacket(null));
        putSupportedElement(new PresencePacket(null));
        putSupportedElement(new PacketErrorNode(null));
    }

    protected AbstractElement getSupportedElement(NSI name, Class iface) {
        AbstractElement elem;
        
        if ((elem = super.getSupportedElement(name, iface)) == null)
            elem = super.getSupportedElement(new NSI(name.getLocalName(), null), iface);
        
        return elem;
    }
}