/*
 * XMLImporter.java
 *
 * Created on October 26, 2002, 5:42 PM
 */

package org.jabberstudio.jso.io;

import org.jabberstudio.jso.StreamElement;

/**
 * <p>
 * Interface to generate <code>StreamElement</code> objects from XML
 * strings.</p>
 *
 * @author  linuxwolf
 * @version 0.13-DEV-20050624155226
 * @since   JSO-0.6
 */
public interface XMLImporter extends Importer {
    //Methods
    /**
     * <p>
     * Generates a <code>StreamElement</code> from an XML string.</p>
     *
     * <p>
     * The import uses the <code>StreamContext</code> from {@link #getContext}
     * for any unknown namespace declarations.</p>
     *
     * <p>
     * The value returned by this method is never <code>null</code>.
     *
     * @param in The XML string to generate from.
     * @return The <code>StreamElement</code> for <code>in</code>
     * @throws RuntimeException If any errors occur generating the
     * <code>StreamElement</code>.
     * @since   JSO-0.6
     */
    public StreamElement read(String in) throws RuntimeException;
}